Bug 468339 - Excessive memory leak when changing background wallpaper
Excessive memory leak when changing background wallpaper
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: gnome-desktop (Show other bugs)
rawhide
All Linux
high Severity high
: ---
: ---
Assigned To: Ray Strode [halfline]
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-24 04:24 EDT by Mamoru TASAKA
Modified: 2008-12-06 09:48 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-12-05 09:36:41 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
memory usage of X (22.47 KB, text/plain)
2008-10-24 04:25 EDT, Mamoru TASAKA
no flags Details

  None (edit)
Description Mamoru TASAKA 2008-10-24 04:24:45 EDT
Description of problem:
Every time I change the background wallpaper on GNOME
the memory usage of X increases and never decreases.

Version-Release number of selected component (if applicable):
control-center-2.24.0.1-8.fc10.i386
metacity-2.24.0-2.fc10.i386
xorg-x11-server-Xorg-1.5.2-8.fc10.i386

Adding to F10DesktopBlocker for now. Please triage.

How reproducible:
100%

Steps to Reproduce:
1. login to GNOME
2. launch gnome-appearance-properties
3. choose Background
4. change wallpaper again and again
5. see the memory usage of Xorg
  
Actual results:
Attached.
Here at last Xorg uses more than 1G memories.

Expected results:
Xorg memory usage should not increase
Comment 1 Mamoru TASAKA 2008-10-24 04:25:35 EDT
Created attachment 321379 [details]
memory usage of X
Comment 2 Ray Strode [halfline] 2008-10-24 14:46:07 EDT
hmm running xrestop on nautilus I get a constant 21 pixmaps after switching the background many times.

memory usage did go up though.

top first reported

2% memory usage and by the end reported 3.2% memory usage.

Mamoru, does that jive with what you're seeing?  xrestop shows no resource increases, but xserver memory usage goes up?
Comment 3 Mamoru TASAKA 2008-10-24 21:18:24 EDT
Well,

(In reply to comment #2)
> hmm running xrestop on nautilus 

On my usage:
[tasaka1@localhost ~]$ gconftool-2 --get /apps/nautilus/preferences/show_desktop
false

and xrestop says (after switching wallpaper repeatedly)

xrestop - Display: localhost:0
          Monitoring 56 clients. XErrors: 0
          Pixmaps:  362052K total, Other:     133K total, All:  362186K total

res-base Wins  GCs Fnts Pxms Misc   Pxm mem  Other   Total   PID Identifier    
1a00000     8   28    0  112  209   380928K	 5K 380933K 30822 gnome-settings-daemon
Comment 4 Matthias Clasen 2008-10-26 18:39:11 EDT
Whats the verdict here ? memleak gone or not ?
Comment 5 Mamoru TASAKA 2008-10-27 00:39:45 EDT
Still I see this memleak.
Comment 6 Ray Strode [halfline] 2008-10-27 10:54:54 EDT
I can reproduce this to, by disabling nautilus.

We leak 1 pixmap every fade.

It's probably a bug in gnome-desktop that only gnome-settings-daemon is hitting and nautilus is missing.
Comment 7 Ray Strode [halfline] 2008-10-27 15:19:53 EDT
This should be fixed in tomorrow's rawhide.
Comment 8 Mamoru TASAKA 2008-10-28 10:02:57 EDT
Seems good, thanks!
Comment 9 Mamoru TASAKA 2008-12-05 03:46:00 EST
It seems that this issue is reappearing with gnome-desktop-2.25.2-3.fc11.
Comment 10 Mamoru TASAKA 2008-12-05 03:51:01 EST
Again:

$ gconftool-2 --get /apps/nautilus/preferences/show_desktop
false

xrestop report:
res-base Wins  GCs Fnts Pxms Misc   Pxm mem  Other   Total   PID Identifier    
1800000     8   28    0  130  206   460288K      5K 460293K  9307 gnome-settings-daemon

ps auwwx report:
root      2567  6.6 36.8 558952 278936 tty7    Ss+  15:36   8:56 /usr/bin/Xorg :0 -br -verbose -auth /var/run/gdm/auth-for-gdm-sXRNeh/database -nolisten tcp
Comment 11 Ray Strode [halfline] 2008-12-05 09:27:12 EST
looking through the diff between before the old patch and the updated patch I see this:

- g_object_ref (old_pixmap);

in gnome_bg_set_pixmap_as_root_with_crossfade ().

Will fix.  Thanks for picking up on this so quickly.
Comment 12 Ray Strode [halfline] 2008-12-05 09:36:41 EST
should be fixed in the latest (still building) build.
Comment 13 Mamoru TASAKA 2008-12-06 09:48:04 EST
Yes, it is fixed, thank you.

Note You need to log in before you can comment on or make changes to this bug.